<?php

namespace Drupal\sendethic;

class SendEthicContact {

  protected ?string $email;
  protected ?string $firstName;
  protected ?string $lastName;
  protected array $attributes = [];

  public function __construct(string $email, string $firstName, string $lastName, ?array $attributes = null) {
    $this->email = $email;
    $this->firstName = $firstName;
    $this->lastName = $lastName;
    $this->attributes = $attributes;
  }

  public function getFirstName() {
    return $this->firstName;
  }

  public function getLastName() {
    return $this->firstName;
  }

  public function getEmail() {
    return $this->email;
  }

  public function getAttributes() {
    return $this->attributes;
  }

  public function toRequestArray(): array {
    $contactAttributes = [
      [
        'id' => 'firstname',
        'fieldName' => 'firstname',
        'fieldValue' => $this->getFirstName(),
      ],
      [
        'id' => 'lastname',
        'fieldName' => 'lastname',
        'fieldValue' => $this->getLastName(),
      ],
      [
        'id' => 'email',
        'fieldName' => 'email',
        'fieldValue' => $this->getEmail(),
      ],
    ];
    foreach (($this->attributes ?: []) as $attributeId => $attributeValue) {
      if (!empty($attributeValue)) {
        $contactAttributes[] = [
          'id' => $attributeId,
          'fieldValue' => is_array($attributeValue) ? join(',', $attributeValue) : $attributeValue,
        ];
      }
    }
    return [
      'attributes' => $contactAttributes,
    ];
  }

}
